function [res_all,vif_out,dw_out,x_deflat_ref]=dimension_tune(model)
    
        // indicateurs d'aide au réglage de la dimension du modèle 
        // 1- sur les b-coefficients
        // 2- sur les matrices X déflatées 
        
        
        x=model.x_ref;
        y=model.y_ref;
        x2=x.d;
        y2=y.d;
        [n,q]=size(x2);
        
        model.b=div(model.b);
        model.err=div(model.err);
        
        ctr=model.center;
        b=model.b.d;
        p=model.loadings.d;
        lv=size(b,2); 
        
        // ----------------------------------
        // application sur les b-coefficients 
        // ----------------------------------
    
        //Durbin-Watson
        dw_d=ica_durbwatmatrix_op(b,'col');
        dw.d=dw_d;
        dw.i='LV'+string([1:lv]');
        dw.v='dw';
        dw=div(dw);
    
        //facteur morphologique 
        mf=dimtune_morph_factor(b);
   //pause     
        //gini 
        resgini=dimtune_gini(b);

        //norme de B
        sce=diag(b'*b);
        bnorm.d=sqrt(sce);
        bnorm.i=dw.i;
        bnorm.v='bnorm';
        bnorm=div(bnorm);
    

        
        // -------------------------------
        // application sur les X deflatées 
        // -------------------------------        
       
        // centrage éventuel de X
        x3=x2-ctr*ones(n,1)*model.x_mean.d';
        y3=y2-ctr*ones(n,1)*model.y_mean.d';
        
        //calcul d'unematrice déflatée pour chaque VL - méthode wold-pls  
        x_deflat_ref=zeros(n,q,lv);
        
        [b_ref,t_ref,p_ref]=calikpls(x3,y3,lv);
        
        xi=x3;
        for i=1:lv;
            ti=t_ref(:,i);
            pi=p_ref(:,i);
            xi=xi-ti*pi';
            x_deflat_ref(:,:,i)=xi;    
        end
  
//        // calcul d'une matrice déflatée pour chaque LV - méthodeJCB 
//        x_deflat=zeros(n,q,lv);
//        
//        s=pinv(x3'*x3);
//        
//        for i=1:lv;
//            pi=p(:,1:i);
//            xi=x3-x3*s*pi*inv(pi'*s*pi)*pi';
//            x_deflat(:,:,i)=xi;
//        end
        
        // kmo-ref
        kmo_ref_d=zeros(lv,1);
        
        for i=1:lv;
            x_deflat_ref_i=x_deflat_ref(:,:,i);
            x_deflat_ref_i=matrix(x_deflat_ref_i,[n,q]);
            kmo_ref_i=dimtune_kaiser_meyer_olkin(x_deflat_ref_i);
            kmo_ref_d(i)=kmo_ref_i;
        end
        
        kmo_ref_res.d=kmo_ref_d;
        kmo_ref_res.i=dw.i;
        kmo_ref_res.v='kmo';
        kmo_ref_res=div(kmo_ref_res);
 
        
//        // kmo-JC
//        kmo_d=zeros(lv,1);
//
//        for i=1:lv;
//            x_deflat_i=x_deflat(:,:,i);
//            x_deflat_i=matrix(x_deflat_i,[n,q]);
//            kmo_i=kaiser_meyer_olkin(x_deflat_i);
//            kmo_d(i)=kmo_i;
//        end
//        
//        kmo_res.d=kmo_d;
//        kmo_res.i=dw.i;
//        kmo_res.v='kmo_eval';
//        kmo_res=div(kmo_res);
//       
//        // kmo transpose 
//        kmot_d=zeros(lv,1);
//
//        for i=1:lv;
//            x_deflat_i=x_deflat(:,:,i);
//            x_deflat_i=matrix(x_deflat_i,[n,q]);
//            x_deflat_i=x_deflat_i';
//            kmot_i=kaiser_meyer_olkin(x_deflat_i);
//            kmot_d(i)=kmot_i;
//        end
//        
//        kmot_res.d=kmot_d;
//        kmot_res.i=dw.i;
//        kmot_res.v='kmo_t';
//        kmot_res=div(kmot_res);       
//    
        
        // VIF 
        
        // choix de la dimension de la pls 
        rmsecv=model.err.d(:,2);
        index=find(rmsecv==min(rmsecv));
        lv_vif=max(index,3);        // au minimum 3 VL 
    
        vif_res=zeros(lv,q);
        
        // pour chaque niveau de déflation
        for i=1:lv;
            xi_vif=x_deflat_ref(:,:,i);
            vif_i=dimtune_var_inflat_factor(xi_vif,lv_vif);
            vif_res(i,:)=vif_i;
        end
    
        vif_out.d=vif_res;
        vif_out.i=model.b.v;
        vif_out.v=model.x_ref.v;
        vif_out=div(vif_out);
    
        // calcul de vif moyen
        vifmatrix_moy.d=mean(vif_res,'c');
        vifmatrix_moy.i=model.b.v;
        vifmatrix_moy.v='vif matrix moy';
        vifmatrix_moy=div(vifmatrix_moy);
    
        // Durbin-Watson sur matrice X 
        dw_res=zeros(lv,q);
        
        for i=1:lv;
            xi_dw=x_deflat_ref(:,:,i);
            dw_i=ica_durbwatmatrix_op(xi_dw,'rows');
            dw_res(i,:)=dw_i;
        end

        dw_out.d=dw_res;
        dw_out.i=vif_out.i;
        dw_out.v=vif_out.v;
        dw_out=div(dw_out);

        // calcul de DW moyen
        dwmatrix_moy.d=mean(dw_res,'c');
        dwmatrix_moy.i=model.b.v;
        dwmatrix_moy.v='dw matrix moy';
        dwmatrix_moy=div(dwmatrix_moy); 

    
        // ------------
        // regroupement
        // ------------
        res_all=[model.err(:,2) bnorm dw mf resgini kmo_ref_res  vifmatrix_moy dwmatrix_moy];
        res_all.d=real(res_all.d);  
      
endfunction
